\documentclass{amsart}

\begin{document}
Suppose you have a %very long comment which would extend far, far, far,
far beyond the maxlinelen.
That comment should obviously be split to the next line.  Okay, fair enough.  But what if that comment % was so long - SO LONG - that even if you split it to the next line, it wouldn't fit under the maxlinelen?
 % in that case, we should respect
 % The user's desire to make ugly comments, and
 % not split

\section*{Indentation}
\begin{foo}\begin{bar}
% Should comments be indented?

Yeah.  Sure.
\end{foo}\end{bar}
\end{document}
